""" File:  fibonacci.py
    Description:  Contains the recursive divide-and-conquer, 
                  and two dynamic programming versions of fibonacci.
"""

def fib(n):
    """ Recursive divide-and-conquer Fibonacci """
    if n == 0:
        return 0
    elif n == 1:
        return 1
    else:
        return fib(n-1) + fib(n-2)

def fib_DP(n):
    """Dynamic programming Fibonacci using a Python list."""
    # List to hold the solutions to the smaller problems
    fibonacci = []
    
    # Step 1: Store base case solutions
    fibonacci.append(0)
    fibonacci.append(1)
    
    # Step 2: Loop from base cases to biggest problem of interest
    for position in range(2, n+1):
        fibonacci.append(fibonacci[position-1] + fibonacci[position-2])
        
    # return nth number in the Fibonacci sequence
    return fibonacci[n]

def fib_DP2(n):
    """Dynamic programming Fibonacci using only three integer variables."""
    fib_old = 0
    fib_current = 1
    
    # Step 2: Loop from base cases to biggest problem of interest
    for count in range(2, n+1):
        fib_next = fib_current + fib_old
        fib_old = fib_current
        fib_current = fib_next
        
    # return nth number in the Fibonacci sequence
    return fib_next
